            #GIT_CMT=5c72db49591175d55b1cd4e1890eff5b0a5ef98b
%define pname oracle-database-preinstall
%define dbrel 23ai
%define prevdbrel 23c
%define configdir /etc/sysconfig
%define logdir /var/log
%define version 1.0
%define release 2%{dist}
%define name %{pname}-%{dbrel}
%global debug_package %{nil}

Summary: Oracle Database Preinstallation RPM
Name: %{name}
Version: %{version}
Release:    2.el8
License: GPLv2
Vendor: Oracle
Source: oracle-database-preinstall-1.0.tar.bz2
Provides: %{name} = %{version}

Conflicts: exadata-base
Obsoletes: %{pname}-%{prevdbrel}
Requires(pre): /etc/redhat-release 
Requires: procps module-init-tools ethtool initscripts bind-utils nfs-utils util-linux-ng pam 
Requires: xorg-x11-utils xorg-x11-xauth smartmontools 
Requires: binutils glibc glibc-devel 
Requires: ksh libaio libgcc libstdc++
Requires: make sysstat openssh-clients 
Requires: psmisc net-tools unzip bc tar 
Requires: fontconfig
%if 0%{?el7} 
Requires: policycoreutils-python
%endif 
%if 0%{?el8} 
Requires: compat-openssl10 policycoreutils policycoreutils-python-utils
%endif
%if 0%{?el9}
#Removed compat-openssl10 for OL9 due to non-availability
Requires: libnsl policycoreutils policycoreutils-python-utils libxcrypt-compat
%endif

BuildRequires: bash
BuildRoot: %{_builddir}/%{pname}-%{version}-root

%description
The Oracle Database Preinstallation RPM automatically installs any additional
packages needed for installing Oracle Grid Infrastructure and Oracle Database
and configures your server operating system automatically, including setting
kernel parameters and other basic operating system requirements for install.

%prep
%setup -q -n %{pname}-%{version}

%build

%install 
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/bin
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/systemd/system
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/security/limits.d
mkdir -p -m 755 $RPM_BUILD_ROOT/%{configdir}/%{name}
mkdir -p -m 700 $RPM_BUILD_ROOT/%{logdir}/%{name}/results
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-verify
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
install -m 600 %{pname}.param $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
cat %{pname}-%{dbrel}.param >> $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
install -m 700 %{pname}-firstboot $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-firstboot
install -m 700 %{pname}-firstboot.service $RPM_BUILD_ROOT/etc/systemd/system/%{name}-firstboot.service
touch $RPM_BUILD_ROOT/etc/security/limits.d/%{name}.conf
ln -f -s %{configdir}/%{name}/%{name}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-firstboot
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/etc/systemd/system/%{name}-firstboot.service
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param

%clean 
rm -rf $RPM_BUILD_ROOT

%define prescript()  \
if [ -f %{configdir}/%{pname}-%1/%{pname}-%1.param ]; then  \
  cp -f %{configdir}/%{pname}-%1/%{pname}-%1.param %{logdir}/%{pname}-%1/results/.%{pname}-%1.param; \
fi; 

%define preunscript()  \
if [ "$1" = "0" ] ; then \
 if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
  systemctl disable %{name}-firstboot.service \
 fi; \
 if [ -x /usr/bin/%{pname}-%1-verify ]; then \
   /usr/bin/%{pname}-%1-verify -u 2> /dev/null 1>&2; \
 fi; \
fi;

%define posttransscript()  \
/usr/bin/%{pname}-%1-verify 2>/dev/null 1>&2; \
if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
	systemctl enable %{pname}-%1-firstboot.service \
fi;

%define postunscript()  \
if [ "$1" = "0" ] ; then \
 if [ -d %{configdir}/%{pname}-%1 ]; then \
   rm -rf %{configdir}/%{pname}-%1; \
 fi; \
 if [ -d %{logdir}/%{pname}-%1 ]; then  \
   rm -rf %{logdir}/%{pname}-%1; \
 fi; \
fi;

#%pre
#%{expand:%%prescript %{dbrel}}

%preun
%{expand:%%preunscript %{dbrel}}

%posttrans
%{expand:%%posttransscript %{dbrel}}

%postun
%{expand:%%postunscript %{dbrel}}

%files
%defattr(-,root,root)
%license LICENSE
%config %{configdir}/%{name}/%{name}.param
%ghost /etc/security/limits.d/%{name}.conf
%{configdir}/%{name}
/etc/systemd/system/%{name}-firstboot.service
%{configdir}/%{name}/%{name}-verify
%{logdir}/%{name}
/usr/bin/%{name}-verify

%changelog
* Fri Apr 26 2024 vasundhara.venkatasubramanian@oracle.com <vasundhara.venkatasubramanian@oracle.com> - 1.0-2.el8
- OL8 spec file linked

* Wed Apr 17 2024 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.el8]
 - Use grubby for setting boot parameters [Orabug: 36487360]
 - Do not set /etc/sysconfig/network parameter for Database versions 23 and 19 [Orabug: 36519881]
 - Fix error in verify script [Orabug: 36454074]
 - Change name to 23ai [Orabug: 36434761]
 - Set transparent_hugepage to madvise [Orabug: 35978247]
 - Set ip_local_port_range to different polarity [Orabug 35580094]
 - Add systemd file for firstboot [Orabug: 35236424]

* Fri Jul 7 2023 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.el8]
 - Redirect output to logfile [Orabug: 35469223]
 - Remove libnsl from dependencies [Orabug: 35448960]
 - Add parameter kernel.panic [Orabug: 35172009]
 - Add fontconfig to the dependencies [ Orabug: 35577976]

* Fri Mar 10 2023 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.5.el8]
 - Incorporate review comments [Orabug: 35168572]

* Fri Mar 3 2023 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.4.el8]
 - Set numa off for aarch64 and fix script errors [Orabug: 35143811]

* Wed Feb 22 2023 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.3.el8]
 - Added policycoreutils [Orabug: 35110034]

* Fri Feb 17 2023 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.2.el8]
 - Code cleanup [Orabug: 35096956]
 - Fixed test log location [Orabug: 34184359]

* Wed Apr 28 2021 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.1.el8]
 - Initial version

